<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (12.0.1) on Sun Jan 12 21:47:51 EST 2020 -->
<title>MessageExchange.Reader (protean-core 1.0.1 API)</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2020-01-12">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
<script type="text/javascript" src="../../../../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../../../../jquery/jquery-3.3.1.js"></script>
<script type="text/javascript" src="../../../../../jquery/jquery-migrate-3.0.1.js"></script>
<script type="text/javascript" src="../../../../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="MessageExchange.Reader (protean-core 1.0.1 API)";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":6,"i1":6,"i2":18,"i3":6,"i4":18,"i5":18,"i6":18,"i7":18,"i8":6,"i9":18,"i10":6,"i11":6,"i12":6,"i13":18,"i14":18,"i15":18,"i16":18,"i17":6,"i18":18};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"],16:["t5","Default Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../../../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">io.gitlab.littlesaints.protean.exchanges</a></div>
<h2 title="Interface MessageExchange.Reader" class="title">Interface MessageExchange.Reader&lt;E&gt;</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt><span class="paramLabel">Type Parameters:</span></dt>
<dd><code>E</code> - the getType of event expected to be read.</dd>
</dl>
<dl>
<dt>Enclosing interface:</dt>
<dd><a href="MessageExchange.html" title="interface in io.gitlab.littlesaints.protean.exchanges">MessageExchange</a>&lt;<a href="MessageExchange.html" title="type parameter in MessageExchange">E</a>&gt;</dd>
</dl>
<hr>
<pre>public static interface <span class="typeNameLabel">MessageExchange.Reader&lt;E&gt;</span></pre>
<div class="block">An interface to read from a resource.
 <br>
 Access by different threads  - The implementations don't support concurrent access but can be accessed serially.
 However, there are methods to support pub-sub <i>like</i> scenarios.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<div class="memberSummary">
<div role="tablist" aria-orientation="horizontal"><button role="tab" aria-selected="true" aria-controls="memberSummary_tabpanel" tabindex="0" onkeydown="switchTab(event)" id="t0" class="activeTableTab">All Methods</button><button role="tab" aria-selected="false" aria-controls="memberSummary_tabpanel" tabindex="-1" onkeydown="switchTab(event)" id="t2" class="tableTab" onclick="show(2);">Instance Methods</button><button role="tab" aria-selected="false" aria-controls="memberSummary_tabpanel" tabindex="-1" onkeydown="switchTab(event)" id="t3" class="tableTab" onclick="show(4);">Abstract Methods</button><button role="tab" aria-selected="false" aria-controls="memberSummary_tabpanel" tabindex="-1" onkeydown="switchTab(event)" id="t5" class="tableTab" onclick="show(16);">Default Methods</button></div>
<div id="memberSummary_tabpanel" role="tabpanel">
<table aria-labelledby="t0">
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tbody>
<tr class="altColor" id="i0">
<td class="colFirst"><code><a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#poll()">poll</a></span>()</code></th>
<td class="colLast">
<div class="block">Try to retrieve an element.</div>
</td>
</tr>
<tr class="rowColor" id="i1">
<td class="colFirst"><code>java.util.List&lt;<a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#poll(int)">poll</a></span>&#8203;(int&nbsp;max)</code></th>
<td class="colLast">
<div class="block">Try to retrieve a number of element until available and the maximum limit is not reached.</div>
</td>
</tr>
<tr class="altColor" id="i2">
<td class="colFirst"><code>default java.util.List&lt;<a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#poll(int,int)">poll</a></span>&#8203;(int&nbsp;max,
    int&nbsp;maxAttempts)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr class="rowColor" id="i3">
<td class="colFirst"><code>java.util.List&lt;<a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#poll(int,int,int)">poll</a></span>&#8203;(int&nbsp;min,
    int&nbsp;max,
    int&nbsp;maxAttempts)</code></th>
<td class="colLast">
<div class="block">Try to retrieve an element.</div>
</td>
</tr>
<tr class="altColor" id="i4">
<td class="colFirst"><code>default boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#poll(int,int,int,java.util.function.Predicate)">poll</a></span>&#8203;(int&nbsp;min,
    int&nbsp;max,
    int&nbsp;maxAttempts,
    java.util.function.Predicate&lt;java.util.List&lt;? super <a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&gt;&nbsp;consumer)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr class="rowColor" id="i5">
<td class="colFirst"><code>default boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#poll(int,int,int,java.util.function.Predicate...)">poll</a></span>&#8203;(int&nbsp;min,
    int&nbsp;max,
    int&nbsp;maxAttempts,
    java.util.function.Predicate&lt;java.util.List&lt;? super <a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&gt;...&nbsp;consumers)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr class="altColor" id="i6">
<td class="colFirst"><code>default boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#poll(int,int,java.util.function.Predicate)">poll</a></span>&#8203;(int&nbsp;max,
    int&nbsp;maxAttempts,
    java.util.function.Predicate&lt;java.util.List&lt;? super <a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&gt;&nbsp;consumer)</code></th>
<td class="colLast">
<div class="block">Try to retrieve a number of element until available and the maximum limit is not reached.</div>
</td>
</tr>
<tr class="rowColor" id="i7">
<td class="colFirst"><code>default boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#poll(int,int,java.util.function.Predicate...)">poll</a></span>&#8203;(int&nbsp;max,
    int&nbsp;maxAttempts,
    java.util.function.Predicate&lt;java.util.List&lt;? super <a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&gt;...&nbsp;consumers)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr class="altColor" id="i8">
<td class="colFirst"><code>boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#poll(int,java.util.function.Predicate)">poll</a></span>&#8203;(int&nbsp;maxAttempts,
    java.util.function.Predicate&lt;? super <a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&nbsp;consumer)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr class="rowColor" id="i9">
<td class="colFirst"><code>default boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#poll(int,java.util.function.Predicate...)">poll</a></span>&#8203;(int&nbsp;maxAttempts,
    java.util.function.Predicate&lt;? super <a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;...&nbsp;consumers)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr class="altColor" id="i10">
<td class="colFirst"><code><a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#take()">take</a></span>()</code></th>
<td class="colLast">
<div class="block">Retrieve a message or block the call otherwise.</div>
</td>
</tr>
<tr class="rowColor" id="i11">
<td class="colFirst"><code>java.util.List&lt;<a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#take(int)">take</a></span>&#8203;(int&nbsp;min)</code></th>
<td class="colLast">
<div class="block">Try to retrieve an element.</div>
</td>
</tr>
<tr class="altColor" id="i12">
<td class="colFirst"><code>java.util.List&lt;<a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#take(int,int)">take</a></span>&#8203;(int&nbsp;min,
    int&nbsp;max)</code></th>
<td class="colLast">
<div class="block">Try to retrieve an element.</div>
</td>
</tr>
<tr class="rowColor" id="i13">
<td class="colFirst"><code>default void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#take(int,int,java.util.function.Predicate)">take</a></span>&#8203;(int&nbsp;min,
    int&nbsp;max,
    java.util.function.Predicate&lt;java.util.List&lt;<a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&gt;&nbsp;consumer)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr class="altColor" id="i14">
<td class="colFirst"><code>default void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#take(int,int,java.util.function.Predicate...)">take</a></span>&#8203;(int&nbsp;min,
    int&nbsp;max,
    java.util.function.Predicate&lt;java.util.List&lt;<a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&gt;...&nbsp;consumers)</code></th>
<td class="colLast">
<div class="block">Retrieve a message and forward it to the consumers, if one is available or block the call otherwise.</div>
</td>
</tr>
<tr class="rowColor" id="i15">
<td class="colFirst"><code>default void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#take(int,java.util.function.Predicate)">take</a></span>&#8203;(int&nbsp;min,
    java.util.function.Predicate&lt;java.util.List&lt;<a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&gt;&nbsp;consumer)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr class="altColor" id="i16">
<td class="colFirst"><code>default void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#take(int,java.util.function.Predicate...)">take</a></span>&#8203;(int&nbsp;min,
    java.util.function.Predicate&lt;java.util.List&lt;<a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&gt;...&nbsp;consumers)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr class="rowColor" id="i17">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#take(java.util.function.Predicate)">take</a></span>&#8203;(java.util.function.Predicate&lt;? super <a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&nbsp;consumer)</code></th>
<td class="colLast">
<div class="block">Retrieve a message and forward it to the consumer, if one is available or block the call otherwise.</div>
</td>
</tr>
<tr class="altColor" id="i18">
<td class="colFirst"><code>default void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#take(java.util.function.Predicate...)">take</a></span>&#8203;(java.util.function.Predicate&lt;? super <a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;...&nbsp;consumers)</code></th>
<td class="colLast">
<div class="block">Retrieve a message and forward it to the consumer, if one is available or block the call otherwise.</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="poll()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>poll</h4>
<pre class="methodSignature"><a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&nbsp;poll()</pre>
<div class="block">Try to retrieve an element. This is a non-blocking operation.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a message if available, or null otherwise.</dd>
</dl>
</li>
</ul>
<a id="poll(int,int,int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>poll</h4>
<pre class="methodSignature">java.util.List&lt;<a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&nbsp;poll&#8203;(int&nbsp;min,
                       int&nbsp;max,
                       int&nbsp;maxAttempts)</pre>
<div class="block">Try to retrieve an element. This is a non-blocking operation.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>min</code> - the minimum elements to read, unless maxAttempts have exhausted.</dd>
<dd><code>max</code> - the maximum elements to read</dd>
<dd><code>maxAttempts</code> - the maximum attempts to read before returning a <code>Collections.emptyList()</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a <code>List</code> of elements, if they're available until shutdown or maxAttempts are exhausted, or <code>Collections.emptyList()</code> otherwise.</dd>
</dl>
</li>
</ul>
<a id="poll(int,int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>poll</h4>
<pre class="methodSignature">default&nbsp;java.util.List&lt;<a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&nbsp;poll&#8203;(int&nbsp;max,
                               int&nbsp;maxAttempts)</pre>
</li>
</ul>
<a id="poll(int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>poll</h4>
<pre class="methodSignature">java.util.List&lt;<a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&nbsp;poll&#8203;(int&nbsp;max)</pre>
<div class="block">Try to retrieve a number of element until available and the maximum limit is not reached. This is a non-blocking operation.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>max</code> - the maximum elements to read</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a <code>List</code> of elements, if they're available until maximum limit is reached, or <code>Collections.emptyList()</code> otherwise.</dd>
</dl>
</li>
</ul>
<a id="poll(int,java.util.function.Predicate)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>poll</h4>
<pre class="methodSignature">boolean&nbsp;poll&#8203;(int&nbsp;maxAttempts,
             java.util.function.Predicate&lt;? super <a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&nbsp;consumer)</pre>
</li>
</ul>
<a id="poll(int,java.util.function.Predicate...)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>poll</h4>
<pre class="methodSignature">default&nbsp;boolean&nbsp;poll&#8203;(int&nbsp;maxAttempts,
                     java.util.function.Predicate&lt;? super <a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;...&nbsp;consumers)</pre>
</li>
</ul>
<a id="poll(int,int,int,java.util.function.Predicate)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>poll</h4>
<pre class="methodSignature">default&nbsp;boolean&nbsp;poll&#8203;(int&nbsp;min,
                     int&nbsp;max,
                     int&nbsp;maxAttempts,
                     java.util.function.Predicate&lt;java.util.List&lt;? super <a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&gt;&nbsp;consumer)</pre>
</li>
</ul>
<a id="poll(int,int,int,java.util.function.Predicate...)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>poll</h4>
<pre class="methodSignature">default&nbsp;boolean&nbsp;poll&#8203;(int&nbsp;min,
                     int&nbsp;max,
                     int&nbsp;maxAttempts,
                     java.util.function.Predicate&lt;java.util.List&lt;? super <a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&gt;...&nbsp;consumers)</pre>
</li>
</ul>
<a id="poll(int,int,java.util.function.Predicate)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>poll</h4>
<pre class="methodSignature">default&nbsp;boolean&nbsp;poll&#8203;(int&nbsp;max,
                     int&nbsp;maxAttempts,
                     java.util.function.Predicate&lt;java.util.List&lt;? super <a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&gt;&nbsp;consumer)</pre>
<div class="block">Try to retrieve a number of element until available and the maximum limit is not reached. This is a non-blocking operation.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>max</code> - </dd>
<dd><code>maxAttempts</code> - </dd>
<dd><code>consumer</code> - </dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>'false' when there are no messages to read and the max attempts are exhausted
 or 'true' when consumer doesn't wish to consume further i.e. the consumer predicate returns false.</dd>
</dl>
</li>
</ul>
<a id="poll(int,int,java.util.function.Predicate...)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>poll</h4>
<pre class="methodSignature">default&nbsp;boolean&nbsp;poll&#8203;(int&nbsp;max,
                     int&nbsp;maxAttempts,
                     java.util.function.Predicate&lt;java.util.List&lt;? super <a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&gt;...&nbsp;consumers)</pre>
</li>
</ul>
<a id="take()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>take</h4>
<pre class="methodSignature"><a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&nbsp;take()</pre>
<div class="block">Retrieve a message or block the call otherwise.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the element if one is readily available or blocking the call until one is available or null if the exchange has been shutdown.
 The application need not check for null unless it's a valid value or it intends to shutdown the exchange in some case.</dd>
</dl>
</li>
</ul>
<a id="take(int,int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>take</h4>
<pre class="methodSignature">java.util.List&lt;<a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&nbsp;take&#8203;(int&nbsp;min,
                       int&nbsp;max)</pre>
<div class="block">Try to retrieve an element. This is a blocking operation.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>min</code> - the minimum elements to read</dd>
<dd><code>max</code> - the maximum elements to read</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a <code>List</code> of elements, if they're available until a terminal state is read or maxAttempts are exhausted, or <code>Collections.emptyList()</code> otherwise.</dd>
</dl>
</li>
</ul>
<a id="take(int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>take</h4>
<pre class="methodSignature">java.util.List&lt;<a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&nbsp;take&#8203;(int&nbsp;min)</pre>
<div class="block">Try to retrieve an element. This is a blocking operation.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>min</code> - the minimum elements to read</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>a <code>List</code> of elements, if they're available until a terminal state is read or maxAttempts are exhausted, or <code>Collections.emptyList()</code> otherwise.</dd>
</dl>
</li>
</ul>
<a id="take(java.util.function.Predicate)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>take</h4>
<pre class="methodSignature">void&nbsp;take&#8203;(java.util.function.Predicate&lt;? super <a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&nbsp;consumer)</pre>
<div class="block">Retrieve a message and forward it to the consumer, if one is available or block the call otherwise.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>consumer</code> - the consumer for the elements. It'll receive the elements until a terminal state is encountered or the consumer returns <i>false</i>.</dd>
</dl>
</li>
</ul>
<a id="take(java.util.function.Predicate...)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>take</h4>
<pre class="methodSignature">default&nbsp;void&nbsp;take&#8203;(java.util.function.Predicate&lt;? super <a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;...&nbsp;consumers)</pre>
<div class="block">Retrieve a message and forward it to the consumer, if one is available or block the call otherwise.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>consumers</code> - the consumers for the elements. They'll receive the elements until a terminal state is encountered or the consumer returns <i>false</i>.</dd>
</dl>
</li>
</ul>
<a id="take(int,int,java.util.function.Predicate)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>take</h4>
<pre class="methodSignature">default&nbsp;void&nbsp;take&#8203;(int&nbsp;min,
                  int&nbsp;max,
                  java.util.function.Predicate&lt;java.util.List&lt;<a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&gt;&nbsp;consumer)</pre>
</li>
</ul>
<a id="take(int,int,java.util.function.Predicate...)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>take</h4>
<pre class="methodSignature">default&nbsp;void&nbsp;take&#8203;(int&nbsp;min,
                  int&nbsp;max,
                  java.util.function.Predicate&lt;java.util.List&lt;<a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&gt;...&nbsp;consumers)</pre>
<div class="block">Retrieve a message and forward it to the consumers, if one is available or block the call otherwise.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>min</code> - the minimum elements to read</dd>
<dd><code>max</code> - the maximum elements to read</dd>
<dd><code>consumers</code> - the consumers for the elements. They'll receive the elements until a terminal state is encountered or the consumer returns <i>false</i>.</dd>
</dl>
</li>
</ul>
<a id="take(int,java.util.function.Predicate)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>take</h4>
<pre class="methodSignature">default&nbsp;void&nbsp;take&#8203;(int&nbsp;min,
                  java.util.function.Predicate&lt;java.util.List&lt;<a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&gt;&nbsp;consumer)</pre>
</li>
</ul>
<a id="take(int,java.util.function.Predicate...)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>take</h4>
<pre class="methodSignature">default&nbsp;void&nbsp;take&#8203;(int&nbsp;min,
                  java.util.function.Predicate&lt;java.util.List&lt;<a href="MessageExchange.Reader.html" title="type parameter in MessageExchange.Reader">E</a>&gt;&gt;...&nbsp;consumers)</pre>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
</footer>
</body>
</html>
